%global         commit cd65bf4f39bf3b7d99953974a8abd93aef5c9f2b
%global         shortcommit %(c=%{commit}; echo ${c:0:7})
%global         commands account hardware journald locale logicalfile networking
%global         commands %{commands} powermanagement realmd selinux service
%global         commands %{commands} software sssd storage
%global         commands %{commands} system
%global         tools_version 0.10.4

Name:           openlmi-scripts
Version:        0.4.0
Release:        4%{?dist}
Summary:        Client-side python modules and command line utilities

License:        GPLv2+
URL:            http://fedorahosted.org/openlmi
Source0:        https://github.com/openlmi/%{name}/archive/%{commit}/%{name}-%{version}-%{shortcommit}.tar.gz
# Due to a move of LMI Meta-command from openlmi-scripts git to openlmi-tools
# and its absence of it in RHEL's openlmi-tools package, it needs to be pulled
# from upstream tarball of openlmi-tools.
Source1:        http://fedorahosted.org/released/openlmi-tools/openlmi-tools-%{tools_version}.tar.gz
Source2:        README-realmd.md
Source3:        README-selinux.md
BuildArch:      noarch
Patch1:         openlmi-tools-0.10.4-python-egg-name.patch
Patch2:         openlmi-tools-0.10.4-support-older-shell.patch

BuildRequires:  python2-devel
# For documentation
BuildRequires:  python-docopt
BuildRequires:  python-sphinx
BuildRequires:  python-sphinx-theme-openlmi
BuildRequires:  openlmi-tools >= 0.9
BuildRequires:  openlmi-tools  < 0.10.0
BuildRequires:  python-IPy
BuildRequires:  ImageMagick
BuildRequires:  pyparsing
Requires:       python2
Requires:       python-docopt >= 0.6.1
Requires:       openlmi-tools >= 0.9
Requires:       openlmi-tools  < 0.10.0
Requires:       pyparsing

%description
Client-side python modules and command line utilities for OpenLMI providers.

%package        doc
Summary:        OpenLMI scripts documentation
Group:          Documentation

%description    doc
This package contains the documents for OpenLMI Scripts.

%package        account
Summary:        Client scripts for OpenLMI Account provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    account
This package contains client side python library for OpenLMI Account
provider and command line wrapper.

%package        hardware
Summary:        Client scripts for OpenLMI Hardware provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    hardware
This package contains client side python library for OpenLMI Hardware
provider and command line wrapper.

%package        journald
Summary:        Client scripts for OpenLMI Journald provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    journald
This package contains client side python library for OpenLMI Journald
provider and command line wrapper.

%package        locale
Summary:        Client scripts for OpenLMI Locale provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    locale
This package contains client side python library for OpenLMI Locale
provider and command line wrapper.

%package        logicalfile
Summary:        Client scripts for OpenLMI Logical File provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    logicalfile
This package contains client side python library for OpenLMI Logical File
provider and command line wrapper.

%package        networking
Summary:        Client scripts for OpenLMI Networking provider
License:        BSD
Requires:       %{name} = %{version}-%{release}
Requires:       python-IPy

%description    networking
This package contains client side python library for OpenLMI Networking
provider and command line wrapper.

%package        powermanagement
Summary:        Client scripts for OpenLMI Power provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    powermanagement
This package contains client side python library for OpenLMI PowerManagement
provider and command line wrapper.

%package        realmd
Summary:        Client scripts for OpenLMI Realmd provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    realmd
This package contains client side python library for OpenLMI Realmd
provider and command line wrapper.

%package        selinux
Summary:        Client scripts for OpenLMI SELinux provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    selinux
This package contains client side python library for OpenLMI SELinux provider
and command line wrapper.

%package        service
Summary:        Client scripts for OpenLMI Service provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    service
This package contains client side python library for OpenLMI Service
provider and command line wrapper.

%package        software
Summary:        Client scripts for OpenLMI Software provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    software
This package contains client side python library for OpenLMI Software
provider and command line wrapper.

%package        sssd
Summary:        Client scripts for OpenLMI SSSD provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    sssd
This package contains client side python library for OpenLMI SSSD provider and
command line wrapper.

%package        storage
Summary:        Client scripts for OpenLMI Storage provider
License:        BSD
Requires:       %{name} = %{version}-%{release}

%description    storage
This package contains client side python library for OpenLMI Storage
provider and command line wrapper.

%package        system
Summary:        Client scripts providing general system information
License:        BSD
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-service >= %{version}-%{release}

%description    system
This package contains client side python library for few OpenLMI providers and
command line wrapper. It's aimed to provide some general information about
system.


%prep
%setup -cqn %{name} -a 1
pushd openlmi-tools-%{tools_version}
%patch1 -p1 -b .python_egg_name
%patch2 -p1 -b .support-olders-shell
popd

find %{name}-%{commit}/commands/ -name '*.py.skel' | xargs sed -i \
    's/\(install_requires\s*=.*\)openlmi-tools[^"'"'"']*/\1%{name} >= %{version}/'

%build
pushd openlmi-tools-%{tools_version}
    make setup
    # build lmi meta-command
    pushd cli
        %{__python2} setup-scripts.py build
    popd # cli

    # build meta-command's documentation
    pushd doc
        # Create a symlink to openlmi-scripts for documentation generator.
        ln -sf %{_builddir}/%{buildsubdir}/%{name}-%{commit} ./%{name}
        # Create setup scripts for all modules.
        pushd openlmi-scripts
            COMMANDS="%{commands}" make setup-all
        popd
    popd # doc
popd # openlmi-tools

pushd %{name}-%{commit}
    # build scripts
    for cmd in %{commands}; do
        pushd commands/$cmd
            %{__python2} setup.py build
        popd # commands/$cmd
    done
popd # openlmi-scripts

pushd openlmi-tools-%{tools_version}/doc
    # build documentation
    WITH_COMMANDS=1 JUST_SCRIPTS=1 COMMANDS="%{commands}" make html
    [ -e build/html/.buildinfo ] && rm build/html/.buildinfo
popd # openlmi-tools/doc

%install
pushd openlmi-tools-%{tools_version}
    # install lmi meta-command
    pushd cli
        %{__python2} setup-scripts.py install -O1 --skip-build --root %{buildroot}
        cp -p lmi/scripts/__init__.* %{buildroot}%{python2_sitelib}/lmi/scripts

        # install man dir
        install -m 0755 -d %{buildroot}%{_mandir}/man1
        install -m 0644 man/lmi.1 %{buildroot}%{_mandir}/man1

        # install config file
        install -m 0755 -d %{buildroot}%{_sysconfdir}/openlmi/scripts
        install -m 0644 config/lmi.conf %{buildroot}%{_sysconfdir}/openlmi/scripts

        # bash completion
        pushd completion
            install -m 0755 -d %{buildroot}%{_sysconfdir}/bash_completion.d
            install -m 0644 lmi.bash %{buildroot}%{_sysconfdir}/bash_completion.d
            install -m 0755 -d %{buildroot}%{_libexecdir}/lmi-bash-completion
            install -m 0755 lmi-bash-completion/print_possible_commands.sh \
                    %{buildroot}%{_libexecdir}/lmi-bash-completion
            cp -pr lmi-bash-completion/commands \
                    %{buildroot}%{_libexecdir}/lmi-bash-completion
        popd # completion
    popd # cli

    # install documentation
    install -m 0755 -d %{buildroot}%{_docdir}/%{name}
    cp -rp doc/build/html %{buildroot}%{_docdir}/%{name}
    install -m 0644 COPYING %{buildroot}%{_docdir}/%{name}
popd # openlmi-tools

pushd %{name}-%{commit}
    # install scripts
    for cmd in %{commands}; do
        pushd commands/$cmd
            %{__python2} setup.py install -O1 --skip-build --root %{buildroot}
            install -m 0755 -d %{buildroot}%{_docdir}/%{name}-$cmd
            install -m 0644 README.md ../../COPYING \
                    %{buildroot}%{_docdir}/%{name}-$cmd
        popd # commands/$cmd

    done

    # install documentation
    install -m 0755 -d %{buildroot}%{_docdir}/%{name}
    install -m 0644 README.md %{buildroot}%{_docdir}/%{name}
popd # openlmi-scripts

install -m 0644 %{SOURCE2} %{buildroot}%{_docdir}/%{name}-realmd/README.md
install -m 0644 %{SOURCE3} %{buildroot}%{_docdir}/%{name}-selinux/README.md

%files
%doc %{_docdir}/%{name}/README.md
%doc %{_docdir}/%{name}/COPYING
%{_bindir}/lmi
%dir %{_sysconfdir}/openlmi/scripts
%config(noreplace) %{_sysconfdir}/openlmi/scripts/lmi.conf
%{_sysconfdir}/bash_completion.d/lmi.bash
%dir %{_libexecdir}/lmi-bash-completion
%dir %{_libexecdir}/lmi-bash-completion/commands
%{_libexecdir}/lmi-bash-completion/*.sh
%{_libexecdir}/lmi-bash-completion/commands/_help
%dir %{python2_sitelib}/lmi/scripts
%{python2_sitelib}/lmi/scripts/__init__.py*
%{python2_sitelib}/lmi/scripts/common
%{python2_sitelib}/lmi/scripts/_metacommand
%{python2_sitelib}/openlmi_scripts-*
%{_mandir}/man1/lmi.1.gz

%files doc
%{_docdir}/%{name}/html

%files account
%doc %{_docdir}/%{name}-account/
%{python2_sitelib}/lmi/scripts/account/
%{python2_sitelib}/openlmi_scripts_account-*

%files hardware
%doc %{_docdir}/%{name}-hardware/
%{python2_sitelib}/lmi/scripts/hardware/
%{python2_sitelib}/openlmi_scripts_hardware-*

%files journald
%doc %{_docdir}/%{name}-journald/
%{python2_sitelib}/lmi/scripts/journald/
%{python2_sitelib}/openlmi_scripts_journald-*

%files locale
%doc %{_docdir}/%{name}-locale/
%{python2_sitelib}/lmi/scripts/locale/
%{python2_sitelib}/openlmi_scripts_locale-*

%files logicalfile
%doc %{_docdir}/%{name}-logicalfile/
%{python2_sitelib}/lmi/scripts/logicalfile/
%{python2_sitelib}/openlmi_scripts_logicalfile-*

%files networking
%doc %{_docdir}/%{name}-networking/
%{python2_sitelib}/lmi/scripts/networking/
%{python2_sitelib}/openlmi_scripts_networking-*

%files powermanagement
%doc %{_docdir}/%{name}-powermanagement/
%{python2_sitelib}/lmi/scripts/powermanagement/
%{python2_sitelib}/openlmi_scripts_powermanagement-*

%files realmd
%doc %{_docdir}/%{name}-realmd/
%{python2_sitelib}/lmi/scripts/realmd/
%{python2_sitelib}/openlmi_scripts_realmd-*

%files selinux
%doc %{_docdir}/%{name}-selinux/
%{python2_sitelib}/lmi/scripts/selinux/
%{python2_sitelib}/openlmi_scripts_selinux-*

%files service
%doc %{_docdir}/%{name}-service/
%{python2_sitelib}/lmi/scripts/service/
%{python2_sitelib}/openlmi_scripts_service-*

%files software
%doc %{_docdir}/%{name}-software/
%{python2_sitelib}/lmi/scripts/software/
%{python2_sitelib}/openlmi_scripts_software-*

%files sssd
%doc %{_docdir}/%{name}-sssd/
%{python2_sitelib}/lmi/scripts/sssd/
%{python2_sitelib}/openlmi_scripts_sssd-*

%files storage
%doc %{_docdir}/%{name}-storage/
%{python2_sitelib}/lmi/scripts/storage/
%{python2_sitelib}/openlmi_scripts_storage-*

%files system
%doc %{_docdir}/%{name}-system/
%{python2_sitelib}/lmi/scripts/system/
%{python2_sitelib}/openlmi_scripts_system-*

%changelog
* Tue Dec 16 2014 Michal Minar <miminar@redhat.com> 0.4.0-4
- Removed explicit dependency on openlmi-python-base.

* Mon Dec 15 2014 Michal Minar <miminar@redhat.com> 0.4.0-3
- Proper support for recent openlmi-tools in rhel7.

* Fri Dec 12 2014 Michal Minar <miminar@redhat.com> 0.4.0-2
- Fixed egg requirements.

* Thu Dec 11 2014 Michal Minar <miminar@redhat.com> 0.4.0-1
- New upstream release.
- New subpackages: locale, realmd, sssd, selinux.
- All documentation is now bundled in single doc package.

* Tue Oct 07 2014 Radek Novacek <rnovacek@redhat.com> 0.3.0-2
- Fix networking script with older openlmi-tools without is_fetched method

* Tue Apr 29 2014 Michal Minar <miminar@redhat.com> 0.3.0-1
- Updated to new upstream version 0.3.0.
- Added openlmi-tools source due to meta-command's absence in source tarball.
- Documentation package ships just documentation for meta-command.
- Each script sub-package now contains related documentation.
- Added journald sub-package.

* Mon Mar 10 2014 Michal Minar <miminar@redhat.com> 0.2.7-8
- Fixed listing of thin volumes/groups in provides.
- Smart hostname selection when no hosts are given.
- System command improvements.
- Fixed storage error reporting.

* Wed Mar 05 2014 Michal Minar <miminar@redhat.com> 0.2.7-7
- Fixed few networking bugs.
- Fixed duplicate headers.

* Tue Mar 04 2014 Michal Minar <miminar@redhat.com> 0.2.7-6
- Fixed search command of software scripts.

* Wed Feb 26 2014 Michal Minar <miminar@redhat.com> 0.2.7-5
- Fixed error handling in service scripts.
- Updated documentation for built-ins commands.
- Fixed checking for thinlv provisioning in storage scripts.

* Tue Feb 25 2014 Michal Minar <miminar@redhat.com> 0.2.7-4
- Removed unstable features from hardware scripts.

* Tue Feb 25 2014 Michal Minar <miminar@redhat.com> 0.2.7-3
- Added account and powermanagement commands.

* Tue Feb 25 2014 Michal Minar <miminar@redhat.com> 0.2.7-2
- Fixed storage mount list command.

* Tue Feb 25 2014 Michal Minar <miminar@redhat.com> 0.2.7-1
- Support older OpenLMI Hardware providers.
- Resolves: bz#1069320

* Mon Feb 24 2014 Michal Minar <miminar@redhat.com> 0.2.7-0
- New upstream version.
- Added system library.

* Wed Jan 15 2014 Michal Minar <miminar@redhat.com> 0.2.6-5
- Added networking library.

* Mon Jan 13 2014 Michal Minar <miminar@redhat.com> 0.2.5-4
- New upstream version.

* Mon Nov 11 2013 Michal Minar <miminar@redhat.com> 0.2.4a-3
- Fixed dependency on openlmi-scripts for subpackages.

* Wed Nov 06 2013 Michal Minar <miminar@redhat.com> 0.2.4a-2
- New upstream version.
- Require openlmi-tools 0.9.

* Tue Oct 29 2013 Michal Minar <miminar@redhat.com> 0.2.3-5
- Made the build dependency on openlmi-tools version specific.

* Tue Oct 29 2013 Michal Minar <miminar@redhat.com> 0.2.3-4
- Fixed build, installation problems and rpmlint errors.

* Thu Oct 17 2013 Michal Minar <miminar@redhat.com> 0.2.3-3
- Require python-docopt on build.
- Do not make configs out of completion scripts.
- Removed _isa macros.

* Wed Oct 16 2013 Michal Minar <miminar@redhat.com> 0.2.3-2
- Require openlmi-providers.
- Own config directory.

* Mon Oct 14 2013 Michal Minar <miminar@redhat.com> 0.2.3-1
- Rebased to 0.2.3
- Added bash completion.
- Added documentation.
- Extended installed commands.
- Divided into subpackages.

* Fri Aug 09 2013 Michal Minar <miminar@redhat.com> 0.1.1-1
- Rebased to 0.1.1

* Thu Aug 08 2013 Michal Minar <miminar@redhat.com> 0.1.0-1
- Initial version.

